/* 
   manae --- skimple kana MANA Exchanger
   completion.c --- manae's completion conversion module
   Copyright 1998-2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/
#ifndef _COMPLETION2_C_
#define _COMPLETION2_C_

#include <PalmOS.h>
#include "id.h"
#include "manae.h"
#include "myfunc.h"

// This software refers Hardware/Hardware.h!
#define NON_PORTABLE
//#include <Hardware/Hardware.h>
#include "Hardware.h"

// powerjog.h contains Mr. Yamada's PowerJOG state control codes.
#include "powerjog.h"

// #define DEBUG

// in kanjidb.c
DmOpenRef OpenMemoDB(GlobalPtr g);
// Err CloseMemoDB(GlobalPtr g);
VoidHand ManaeGetCandRec(GlobalPtr g);
Err ManaeReleaseCandRec(GlobalPtr g);
VoidHand ManaeGetUserCandRec(GlobalPtr g);
Err ManaeReleaseUserCandRec(GlobalPtr g);
VoidHand ManaeGetLearnCandRec(GlobalPtr g);
Err ManaeReleaseLearnCandRec(GlobalPtr g);

// cands.c
CharPtr searchLearnYomiCompl(CharPtr yomiP, VoidPtr learnP,
			     VoidPtr boundaryP);
int BM1(unsigned char *pat, int patLen, unsigned char *text, int textLen);
Int searchStr7(CharPtr patP, CharPtr textP, Int start,
	       ULong textLen, Char sep, Int *nextStartP);

Boolean DComplStart(GlobalPtr g);
Boolean DComplEnd(GlobalPtr g);
Int DComplGetACandLearn(CharPtr yomiP, Int start, VoidPtr dicP,
			ULong dicLen);
Int DComplGetCands(CharPtr yomiP, GlobalPtr g);
Boolean DComplShow(GlobalPtr g);
Boolean DComplSelectCand(CharPtr yomiP, CharPtr kanjiP,
			 EventPtr eventP, GlobalPtr g);

// macro

#define C(I) ((CTPtr)((ULong)g->dcP->cands + (ULong)(sizeof(CT)) * (ULong)I))

// static functions

static RectangleType ViewGetRect(GlobalPtr g)
{
  RectangleType r;
  Int fontHeight;
  Coord extentX, extentY;

  fontHeight = FntCharHeight();
  WinGetDisplayExtent(&extentX, &extentY);

  r.topLeft.x = 0;
  r.topLeft.y = g->insPtY + fontHeight + 3;
  WinWindowToDisplayPt(&r.topLeft.x, &r.topLeft.y); // r.topLeft.x may change.
  r.topLeft.x = 0;
  r.extent.x = extentX - 1;
  r.topLeft.y = 
    ((r.topLeft.y + (fontHeight + 1)) >= extentY) ?
    r.topLeft.y - (fontHeight + 1) * 2 : r.topLeft.y;
  r.extent.y = (fontHeight + 1);
  return(r);
}

static void ViewErase(GlobalPtr g)
{
  RectangleType r;

  r = ViewGetRect(g);

  WinEraseRectangle(&r, 0);
  return;
}


// Description:
//	Save Original View
//
// Returned:
//	true	success
static WinHandle ViewSaveBuffer(GlobalPtr g)
{
  RectangleType r;
  Word err;

  r = ViewGetRect(g);
  return(WinSaveBits(&r, &err));
}

// Description:
//	Restore Original View
//
// Returned:
//	true	success
Boolean ViewRestoreBuffer(WinHandle savedWinH, GlobalPtr g)
{
  RectangleType r;

  if (savedWinH == NULL) return(false);

  r = ViewGetRect(g);
  WinRestoreBits(savedWinH, r.topLeft.x, r.topLeft.y);

  return(true);
}

Boolean DComplStart(GlobalPtr g)
{

  if (g->dcP != NULL) {
    //    ErrorPrintNum(ERRWARNING, 0, 0);
    //    DComplEnd(g);
  }
  g->dcP = NULL;

  if (ManaeGetLearnCandRec(g) == false) {
    ErrorPrint("Can't get learndic", 0, 0);
    return(false);
  }
  if ((g->dcP = MemPtrNew(sizeof(DC))) == NULL) {
    ManaeReleaseLearnCandRec(g);
    ErrorPrint("Can't get dcP", 0, 0);
    return(false);
  }
  //  MemPtrSetOwner(g->dcP, 0); // Never Garbage collected.

  if ((g->dcP->savedWinH = ViewSaveBuffer(g)) == NULL) {
    ManaeReleaseLearnCandRec(g);
    MemPtrFree(g->dcP);
    ErrorPrint("Can't get savedWinH", 0, 0);
    g->dcP = NULL;
    return(false);
  }

  //  g->dcP->candsIdx[0] = -1;

  // Stop PowerJOG
  PowerJOGChangeStateOld(false);
  PowerJOGChangeState(false);

  if ((g->dcP->cands = MemPtrNew((sizeof(CT)) * NUMDCCANDS)) == NULL) {
    ManaeReleaseLearnCandRec(g);
    ViewRestoreBuffer(g->dcP->savedWinH, g);
    MemPtrFree(g->dcP);
    g->dcP = NULL;
    return(false);
  }

  g->dcP->yomi2ndChr = nullChr;
  C(0)->dicType = NODIC;
  C(0)->yomiOft = -1;
  return(true);
}

Boolean DComplEnd(GlobalPtr g)
{
  if (g->dcP == NULL) {
    // ErrorPrintNum(ERRWARNING, 0, 0);
    //    ErrorPrint("g->dcP == NULL", 0, 0);
    return(true);
  }

  if (ManaeReleaseLearnCandRec(g) != 0) {
    //    ErrorPrintNum(ERRWARNING, 0, 0);
  }

  if (ManaeReleaseCandRec(g) != 0) {
    //    ErrorPrintNum(ERRWARNING, 0, 0);
  }

  if (g->dcP->savedWinH != NULL) {
    ViewRestoreBuffer(g->dcP->savedWinH, g);
    g->dcP->savedWinH = NULL;
  }

  if (g->dcP->cands != NULL) {
    MemPtrFree(g->dcP->cands);
    g->dcP->cands = NULL;
  }

  if (MemPtrFree(g->dcP) != 0) {
    ErrorPrint("fatal error", 0, 0);
  }
  g->dcP = NULL;

  // (Re)Start PowerJOG
  PowerJOGChangeStateOld(true);
  PowerJOGChangeState(true);
  return(true);
}


// Returned:
//	i is a cand yomigana position (counts from dicP)
Int DComplGetACandLearn(CharPtr yomiP, Int start, VoidPtr dicP,
			ULong dicLen)
{
  CharPtr p;

  if (dicP == NULL) {
    return(-1);
  }

  if ((p = (CharPtr)searchLearnYomiCompl(yomiP, dicP + start, dicP + dicLen))
      == NULL) return(-1);
  return((Int)(p + 1 - (CharPtr)dicP));
}

// Returned:
//	i is a candidate's yomigana position (counts from dicP)
Int DComplGetACandJos(CharPtr yomiP, Int start, VoidPtr dicP,
		      ULong dicLen)
{
  int candPos, add;
  Int yomiLen;

  if (dicP == NULL) {
    return(-1);
  }

  yomiLen = MyStrLen(yomiP);
  if (yomiLen <= 2) {
    return(0);
  }

  for (candPos = start;
       ((add = 
	 BM1((yomiP + 2), (int)(yomiLen - 2), (dicP + candPos),
	     (dicLen - candPos))) != -1); candPos++) {
    candPos += add;
    if (candPos == 0) {
      return(candPos);
    }
    if (*(CharPtr)(dicP + candPos - 1) == crChr) {
      return(candPos);
    }
  }
  return(-1);
}

// Returned:
//	i is a candidate's yomigana position (counts from dicP)
Int DComplGetTheSameCandJos(CharPtr yomiP, Int start, VoidPtr dicP,
			    ULong dicLen)
{
  Int nextStart;

  if (dicP == NULL) {
    return(-1);
  }

  if (MyStrLen(yomiP) < 4) {
    return(-1);
  }
  nextStart = start;
  return(searchStr7(yomiP + 2, dicP, nextStart, dicLen, '/', &nextStart));
}


// Returned:
//	candidates index number (not the number of found candidates).
Int DComplGetCands(CharPtr yomiP, GlobalPtr g)
{
  Int i, curr;

  C(0)->dicType = NODIC;
  C(0)->recP = NULL;
  C(0)->yomiOft = -1;
  C(0)->kanjiOft = -1;

  // Close a J-OS record, if necessary and
  // Get a JOS record.
  if (*(yomiP + 1) != g->dcP->yomi2ndChr) {
    if (g->dicH != NULL) {
      ManaeReleaseCandRec(g);
    }

    if (*(yomiP + 1) == nullChr) {
      g->dcP->yomi2ndChr = nullChr;
      C(0)->dicType = NODIC;
      C(0)->recP = NULL;
      C(0)->yomiOft = -1;
      C(0)->kanjiOft = -1;
      return(-1); // No yomigana, No candidate!!!
    } else {
      ManaeGetCandRec(g);
      g->dcP->yomi2ndChr = *(yomiP + 1);
    }
  }

  // A J-OS Dic Record have already been opened.

  // At first, search in the learing dic.
  for (i = 0, curr = g->learnDicStartPoint;
       (i < NUMDCCANDS);
       i++) {
    if (curr >= (Int)g->learnDicLen) {
      // All items in learing dic have been searched.
      C(i)->dicType = NODIC;
      C(i)->recP = NULL;
      C(i)->yomiOft = -1;
      C(i)->kanjiOft = -1;
      break; // skip searching in the learing dic.
    }
    if ((C(i)->yomiOft = 
	 DComplGetACandLearn(yomiP, curr, g->learnDicP, g->learnDicLen))
	== -1) {
      // if no more candidate in learning dictionary, exit loop.
      break;
    } else {
      // set a candidate.
      C(i)->dicType = LEARNDIC;
      C(i)->recP = g->learnDicP;
      C(i)->kanjiOft = nextSepOft(C(i)->recP, C(i)->yomiOft,  '/') + 1;

      // skip to a next candidate.
      // search a linefeedChr
      for (curr = C(i)->yomiOft;
	   ((*(CharPtr)(C(i)->recP + curr) != linefeedChr) &&
	    (curr < g->learnDicLen));
	   curr++);

      // skip linefeedChrs
      for (;
	   ((*(CharPtr)(C(i)->recP + curr) == linefeedChr) &&
	     (curr < g->learnDicLen));
	   curr++);

    }
  }

  if (i < NUMDCCANDS) {
    Int nextStart = 0;

    // search in JOS dic.
    if ((C(i)->yomiOft = 
	 DComplGetACandJos(yomiP, nextStart, g->candP, g->candRecLen))
	!= -1) {

      // A candidate is found.
      C(i)->dicType = JOSDIC;
      C(i)->recP = g->candP;
      C(i)->kanjiOft = 
	nextSepOft(C(i)->recP, C(i)->yomiOft, '/') + 1;
      nextStart = C(i)->kanjiOft; // 
      i++;
    }
    if (i < NUMDCCANDS) {
      // search the same yomigana in JOS dic.
      if ((C(i)->yomiOft = 
	   DComplGetTheSameCandJos(yomiP, nextStart, g->candP, g->candRecLen))
	  != -1) {
	// A candidate is found.
	C(i)->dicType = JOSDIC;
	C(i)->recP = g->candP;
	C(i)->kanjiOft =
	  nextSepOft(C(i)->recP, C(i)->yomiOft, '/') + 1;

	i++;
      }
    }
  }

  if (i < NUMDCCANDS) {
    C(i)->dicType = NODIC;
    C(i)->recP = NULL;
    C(i)->yomiOft = -1;
    C(i)->kanjiOft = -1;
  }
  return(i); // return the number of candidates.
}

// Description:
//	View a completion buffer.
//
// Returned:
//	true	success
Boolean DComplShow(GlobalPtr g)
{
  // currently do nothing.
  CharPtr show;
  Int i, j, k;
  SWord x;
  RectangleType r;
  Int candStrPnt[NUMDCCANDS];
  Int fontHeight;
  Int fontWidth;
  Coord extentX, extentY;

  if (g->dcP == NULL) {
    return(false);
  }

  ViewErase(g);
  
  if ((show = MemPtrNew(SHOWLEN + 2)) == NULL) {
    return(false);
  }

  for(i = 0, j = 0;
      ((i < NUMDCCANDS) &&
       (C(i)->yomiOft != -1) &&
       (j < SHOWLEN));
      i++) {

    switch (C(i)->dicType) {
      Char c;

    case LEARNDIC:
      for (k = 0;
	   (((c = *(C(i)->recP + C(i)->kanjiOft + k)) != linefeedChr) &&
	    (j < SHOWLEN));
	   j++, k++) {
	show[j] = c;
      }
      break;

    case JOSDIC:
      for (k = 0;
	   (((c = *(C(i)->recP + C(i)->kanjiOft + k)) != crChr) &&
	    (c != '/') &&
	    (j < SHOWLEN));
	   j++, k++) {
	show[j] = c;
      }
      break;

    case USERDIC:
    case NODIC:
    default:
      break;
    }

    candStrPnt[i] = j;
    show[j++] = 0x81; // Zenkaku space.
    show[j++] = 0x40;

  }

  fontHeight = FntCharHeight();
  fontWidth = FntCharsWidth("", 2);
  r = ViewGetRect(g);
  WinGetDisplayExtent(&extentX, &extentY);

  x = (((g->insPtX + (j / 2 * fontWidth)) > extentX) ?
    (extentX - (SWord)(j / 2 * fontWidth)) : g->insPtX);
  WinDrawChars(show, j, x, r.topLeft.y);
  
  // reverse a selected candidate.
  if (g->complSeleNum < i) {
    switch (g->complSeleNum) {
      
    case 0:
      r.topLeft.x = x; 
      r.extent.x = (candStrPnt[g->complSeleNum]  / 2) * fontWidth;

      //      r.topLeft.y = g->insPtY + fontHeight + 2;
      //      r.topLeft.y = 
      //	((r.topLeft.y + (fontHeight + 2) * 2) >= extentY) ?
      //	r.topLeft.y - (fontHeight + 2) * 2 : r.topLeft.y;
      //      r.extent.y = (fontHeight + 1);
      WinInvertRectangle(&r, 0);
      break;

    case 1:
    case 2:
      r.topLeft.x = x + (candStrPnt[g->complSeleNum - 1] + 2) / 2 * fontWidth;
      r.extent.x = (candStrPnt[g->complSeleNum] - 
		    candStrPnt[g->complSeleNum - 1] - 2) * fontWidth / 2;

      //      r.topLeft.y = g->insPtY + fontHeight + 2;
      //      r.extent.y = fontHeight + 1;
      //      r.topLeft.y = 
      //	((r.topLeft.y + (fontHeight + 2) * 2) >= extentY) ?
      //	r.topLeft.y - (fontHeight + 2) * 2 : r.topLeft.y;
      //      r.extent.y = (fontHeight + 1);

      WinInvertRectangle(&r, 0);
      break;

    default:
      // do nothing;
      break;
    }
  }
  
  MemPtrFree(show);
  return(true);
}

static Int isDCompl(EventPtr eventP, GlobalPtr g)
{
  Int ret;

  switch (eventP->data.keyDown.chr) {
  case '1':
    return(0);
  case '2':
    return(1);
  case '3':
    return(2);

  case vchrJogRelease:
    ret = g->complSeleNum;
    g->complSeleNum = -1;
    return(ret);

  case vchrJogPress:
    g->complSeleNum = 0;
    DComplShow(g);
    return(-1);

  case vchrJogPageUp:
    g->complSeleNum = (((g->complSeleNum) - 1) < 0) ?
      0 : g->complSeleNum - 1;
    DComplShow(g);
    //
    eventP->data.keyDown.chr = nullChr;
    //
    return(-1);

  case vchrJogPageDown:
    g->complSeleNum = (((g->complSeleNum) + 1) >= NUMDCCANDS) ?
      NUMDCCANDS - 1 : g->complSeleNum + 1;
    DComplShow(g);
    //
    eventP->data.keyDown.chr = nullChr;
    //
    return(-1);

  case vchrJogPressRepeat:
    DComplShow(g);
    return(-1);
  }

  if (g->thumbTypeMode) { 
    return(-1);
  }

  if (eventP->data.keyDown.chr != '.') {
    return(-1);
  }

  return(GetGraffitiRegion(g->event->screenX, g->event->screenY,
			   g->encoding, g->romVersion));  
}

// This dose not check the size of yomi nor kanjib.
// Returned:
//	Selected	true
Boolean DComplSelectCand(CharPtr yomiP, CharPtr kanjiP,
			 EventPtr eventP, GlobalPtr g)
{
  Int i, j;
  Char c;

  if (g->dcP == NULL) {
    return(false); 
  }

#ifdef DEBUG 
  ULong free, max;
  
  Char mess[20];

  MemHeapFreeBytes(0, &free, &max);
  StrPrintF(mess, "%ld, %ld", free, max);
  ErrorPrint(mess, 80, 0);
  
#endif
  
  if ((i = isDCompl(eventP, g)) == -1) {
    return(false);
  }

  if (g->dcP == NULL) {
    return(false);
  }

  for (j = 0; j <= i ; j++) {
    if (C(i)->yomiOft == -1) {
    return(false);
    }
  }

  // copy the yomigana and kanji form the dictitionary.
  switch (C(i)->dicType) {
   
  case LEARNDIC:

    for (j = 0;
	 (c = *(C(i)->recP + C(i)->kanjiOft + j)) != linefeedChr; j++) {
      kanjiP[j] = c;
    }
    kanjiP[j] = nullChr;
    
    for (j = 0;
	 (c = *(C(i)->recP + C(i)->yomiOft + j)) != '/'; j++) {
      yomiP[j] = c;
    }
    yomiP[j] = nullChr;
    break;

  case JOSDIC:

    for (j = 0;
	 (((c = *(C(i)->recP + C(i)->kanjiOft + j)) != '/') &&
	  (c  !=  crChr)); 
	 j++) {
      kanjiP[j] = c;
    }
    kanjiP[j] = nullChr;

    // copy the first yomigana and
    j = 0;
    yomiP[j++] = *g->kanaP;
    yomiP[j++] = *(g->kanaP + 1);

    // rest yomigana is copied from the dicitionary.
    for (;
	 (c = *(C(i)->recP + C(i)->yomiOft + j)) != '/';
	 j++) {
      yomiP[j] = c;
    }
    yomiP[j] = nullChr;
    break;

  case USERDIC:
  case NODIC:
  default:
    *yomiP = nullChr;
    *kanjiP = nullChr;
    return(false);
    break;
  }

#ifdef DEBUG
  ErrorPrint(yomiP, 0, 150);
  ErrorPrint(kanjiP, 100, 150);
#endif
  return(true);
}
#endif
