/* 
   manae --- skimple kana MANA Exchanger
   manae.c --- Main Module
   Copyright 1998-2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#ifndef _MYFUNC_C_
#define _MYFUNC_C_

//#pragma pack(2)

// #include <stdio.h>
// #include <System/SysAll.h>
// #include <UI/UIAll.h>
// #include <System/FeatureMgr.h>
#include <PalmOS.h>

#include <HandEra/Trg.h>
#include <HandEra/Silk.h>
#include <HandEra/Vga.h>
#include "id.h"
#include "manae.h"
#include "myfunc.h"

// This software refers Hardware/Hardware.h!
#define NON_PORTABLE
// #include <Hardware/Hardware.h>
#include "Hardware.h"

// my functions

void ErrorPrintHex(ULong hex, SWord x, SWord y)
{
  Char s[15];

  StrPrintF(s, "%lx", hex);
  WinDrawChars(s, StrLen(s), x, y);
}

void ErrorPrintNum(Int i, SWord x, SWord y)
{
  Char s[35];
  StrPrintF(s, "%d", i);
  WinDrawChars(s, StrLen(s), x, y);
}

// StrNCopy Clone.
CharPtr mystrncpy(CharPtr d, const Char* s, Word n)
{
  Word i;
  for (i = 0; ((i < n) && (s[i] != nullChr)); i++) {
    d[i] = s[i];
  }
  for (; i < n; i++) {
    d[i] = nullChr;
  }
  d[n] = nullChr;
  return(d);
}

// Is c consonant?
Boolean isconsonant(Char c)
{
  Int i;

  static const Char consonant[] = {'k', 's', 't', 'n', 'h', 'm', 'y', 'r', 'w',
				   'g', 'z', 'd', 'b', 'v', 'j', 'p', 'f', 'c',
				   'x', '\0'};


  for (i = 0; consonant[i] != nullChr; i++) {
    if (consonant[i] == c) return true;
  }
  return false;
}

// Is c vowel?
Boolean isvowel(Char c)
{
  Int i;

  static const Char vowel[] = {'a', 'i', 'u', 'e', 'o', '\0'};

  for (i = 0; vowel[i] != nullChr; i++) {
    if (vowel[i] == c) return true;
  }
  return false;
}

// Returned:
// a -> 0, i ->1, u ->2, e -> 3, o -> 4
// other -> 5
Int vowelNum(Char c)
{
  Int i;

  static const Char vowel[] = {'a', 'i', 'u', 'e', 'o', '\0'};

  for (i = 0; vowel[i] != nullChr; i++) {
    if (vowel[i] == c) return i;
  }
  return 5;
}

// convert space to null.
// Returned: converted -> true;
Boolean space2Null(CharPtr s)
{
  Int i;

  for(i = 0; s[i] != nullChr; i++) {
    if (s[i] == ' ') {
      s[i] = nullChr;
      return(true);
    }
  }
  return(false);
}

// add one char to the string.
// RETURNED:	new string length.
Int addChar(CharPtr str, Char c)
{
  Int i;
  for (i = 0; str[i] != nullChr; i++) {}
  
  str[i] = c;
  str[i + 1] = nullChr;
  return(i + 1);
}

CharPtr MyDmStrCat(CharPtr dst, CharPtr src)
{
  ULong dstLen, srcLen;

  for (dstLen = 0; *(dst + dstLen) != nullChr; dstLen++);
  for (srcLen = 0; *(src + srcLen) != nullChr; srcLen++);
  DmWrite(dst, dstLen, src, srcLen + 1); // + 1 for nullChr
  return(dst);
}

UInt MyDmGetOpenDatabaseVersion(DmOpenRef dbR)
{
  LocalID dbID;
  UInt openCount;
  UInt mode;
  UInt cardNo;
  Boolean resDB;

  Char name;
  UInt attributes;
  UInt version;
  ULong crDate;
  ULong modDate;
  ULong bckUpDate;
  ULong modNum;
  LocalID appInfoID;
  LocalID sortInfoID;
  ULong type;
  ULong creator;

  if (DmOpenDatabaseInfo(dbR, &dbID, &openCount, &mode, &cardNo, &resDB)
      == 0) {
    if (DmDatabaseInfo(cardNo, dbID,
		       &name, &attributes,
		       &version, &crDate,
		       &modDate, &bckUpDate,
		       &modNum, &appInfoID,
		       &sortInfoID, &type,
		       &creator) == 0) {
      return(version);
    }
  }
  return(0); // error
}

UInt MyDmGetDatabaseVersionByTypeCreator(ULong type, ULong creator)
{
  DmSearchStateType stateInfo;
  UInt cardNo;
  LocalID dbID;

  Char name;
  UInt attributes;
  UInt version;
  ULong crDate;
  ULong modDate;
  ULong bckUpDate;
  ULong modNum;
  LocalID appInfoID;
  LocalID sortInfoID;

  if (DmGetNextDatabaseByTypeCreator(true, &stateInfo, type, creator, true,
				     &cardNo, &dbID)
      == 0) {
    if (DmDatabaseInfo(cardNo, dbID,
		       &name, &attributes,
		       &version, &crDate,
		       &modDate, &bckUpDate,
		       &modNum, &appInfoID,
		       &sortInfoID, &type,
		       &creator) == 0) {
      return(version);
    }
  }
  return(0); // error
}

Err MyDmSetDatabaseVersionByTypeCreator(ULong type, ULong creator,
					UInt version)
{
  DmSearchStateType stateInfo;
  UInt cardNo;
  LocalID dbID;
  Err err;

  if ((err = DmGetNextDatabaseByTypeCreator(true, &stateInfo,
					    type, creator, true,
					    &cardNo, &dbID))
      == 0) {
    return(DmSetDatabaseInfo(cardNo, dbID,
			     NULL, NULL,
			     &version, NULL,
			     NULL, NULL,
			     NULL, NULL,
			     NULL, NULL,
			     NULL));
  }
  return(err); // error
}

Err MyDmDeleteDatabaseByTypeCreator(ULong type, ULong creator)
{
  DmSearchStateType stateInfo;
  UInt cardNo;
  LocalID dbID;
  Err err;

  if ((err = DmGetNextDatabaseByTypeCreator(true, &stateInfo,
					    type, creator, true,
					    &cardNo, &dbID))
      == 0) {
    return(DmDeleteDatabase(cardNo, dbID));
  }
  return(err);
}

WinHandle MyDrawCharSave(CharPtr chars, Word len, SWord x, SWord y)
{
  RectangleType r;
  WinHandle h;
  Word err;

  r.topLeft.x = x;
  r.topLeft.y = y;
  WinWindowToDisplayPt(&r.topLeft.x, &r.topLeft.y);
  r.extent.x = 
    ((FONTWIDTH * len / 2 + r.topLeft.x + 5) > (hwrDisplayWidth - 1)) ?
    (hwrDisplayWidth - r.topLeft.x - 1) :
    (FONTWIDTH * len / 2 + r.topLeft.x + 5);
  r.extent.y = FONTHEIGHT + 2;
  
  h = WinSaveBits(&r, &err);
  WinDrawChars(chars, len, x, y);
  return(h);
}
    
void MyRestore(WinHandle h, Word len, SWord x, SWord y)
{
  RectangleType r;

  if (h == NULL) return;

  r.topLeft.x = x;
  r.topLeft.y = y;
  WinWindowToDisplayPt(&r.topLeft.x, &r.topLeft.y);
  r.extent.x = 
    ((FONTWIDTH * len / 2 + r.topLeft.x + 5) > (hwrDisplayWidth - 1)) ?
    (hwrDisplayWidth - r.topLeft.x - 1) :
    (FONTWIDTH * len / 2 + r.topLeft.x + 5);
  r.extent.y = FONTHEIGHT + 2;
  
  WinRestoreBits(h, x, y);
  return;
}

Err GetAreasTRG(RectangleType *alphaEntryP, RectangleType
	       *numericEntryP)
{
  UInt32 version, romVerMajor;
  Err err;
  
  err = appErrorClass + ERR_1;

  if (FtrGet(TRGSysFtrID, TRGSilkFtrNum, &version) == 0) {
    if ((romVerMajor = sysGetROMVerMajor(version)) == 1) {
      // the Silk Extension 1.0 or higher is present
      err = SilkGetAreas(alphaEntryP, numericEntryP);
      alphaEntryP->topLeft.y = 246;
      alphaEntryP->extent.y = 73;
      return(err);
    }
    if (romVerMajor > 1) {
      // the Silk Extension 1.0 or higher is present
      err = SilkGetAreas(alphaEntryP, numericEntryP);
      /*
      ErrorPrintHex(version, 0, 150);
      ErrorPrintHex(sysGetROMVerMajor(version), 80, 150);
      ErrorPrintNum(alphaEntryP->topLeft.x, 0, 0);
      ErrorPrintNum(alphaEntryP->topLeft.y, 30, 0);
      ErrorPrintNum(alphaEntryP->extent.x, 60, 0);
      ErrorPrintNum(alphaEntryP->extent.y, 90, 0);
      ErrorPrintNum(numericEntryP->topLeft.x, 0, 10);
      ErrorPrintNum(numericEntryP->topLeft.y, 30, 10);
      ErrorPrintNum(numericEntryP->extent.x, 60, 10);
      ErrorPrintNum(numericEntryP->extent.y, 90, 10);
      */
      return(err);
    }
  }
  return(err);
}

Err GetAreasOS35(RectangleType *alphaEntryP, RectangleType *numericEntryP)
{
  Boolean alphaF, numericF;
  Int numAreas;
  SilkscreenAreaType *silkP;
  Int i;

  if (GetAreasTRG(alphaEntryP, numericEntryP) == errNone) {
    return(errNone);
  }

  alphaF = false;
  numericF = false;

  silkP = (SilkscreenAreaType *)EvtGetSilkscreenAreaList(&numAreas);

  for (i = 0; i < numAreas; i++) {
    if ((silkP + i)->areaType == silkscreenRectGraffiti) {
      if ((silkP + i)->index == alphaGraffitiSilkscreenArea) {
	if (alphaEntryP != NULL) {
	  *alphaEntryP = (silkP + i)->bounds;
	  alphaF = true;
	} 
      } else {
	if ((silkP + i)->index == numericGraffitiSilkscreenArea) {
	  if (alphaEntryP != NULL) {
	    *numericEntryP = (silkP + i)->bounds;
	    numericF = true;
	  }
	}
      }
    }
  }
  if (((alphaF == false) && (alphaEntryP != NULL)) ||
      ((numericF == false) && (alphaEntryP != NULL))) {
    return(appErrorClass + ERR_1);
  }
  return(errNone);
}

Err GetAreasOS20(RectangleType *alphaEntryP, RectangleType *numericEntryP)
{
  alphaEntryP->topLeft.x = hwrGraffitiLeft;
  alphaEntryP->topLeft.y = hwrGraffitiTop;
  alphaEntryP->extent.x = hwrGraffitiSplit - hwrGraffitiLeft;
  alphaEntryP->extent.y = hwrGraffitiHeight;
  numericEntryP->topLeft.x = hwrGraffitiSplit;
  numericEntryP->topLeft.y = hwrGraffitiTop;
  numericEntryP->extent.x = hwrGraffitiLeft + hwrGraffitiWidth -
    hwrGraffitiSplit;
  numericEntryP->extent.y = hwrGraffitiHeight;
  return(errNone);
}

Err GetAreas(RectangleType *alphaEntryP, RectangleType *numericEntryP, 
	     ULong romVersion)
{
  if (romVersion >= 0x03500000) {
    //    ErrorPrint("ROM > 35", 0, 150);
    return(GetAreasOS35(alphaEntryP, numericEntryP));
  }
  return(GetAreasOS20(alphaEntryP, numericEntryP));
}

/*

// Returned:
//	Error:	-1
Int GetGraffitiRegionOS35(SWord screenX, SWord screenY)
{
  SWord dispX, dispY;
  Int numAreas;
  SilkscreenAreaType *silkP;
  Int i, alphaI, numericI;

  silkP = (SilkscreenAreaType *)EvtGetSilkscreenAreaList(&numAreas);

  for (i = 0, alphaI = -1, numericI = -1; i < numAreas; i++) {
    if ((silkP + i)->areaType == silkscreenRectGraffiti) {
      if ((silkP + i)->index == alphaGraffitiSilkscreenArea) {
	alphaI = i;
      } else {
	if ((silkP + i)->index == numericGraffitiSilkscreenArea) {
	  numericI = i;
	}
      }
    }
  }
  if ((alphaI == -1) || (numericI == -1)) {
    return(-1);
  }

  dispX = screenX;
  dispY = screenY;
  WinWindowToDisplayPt(&dispX, &dispY);

  if ((dispY < (silkP + alphaI)->bounds.topLeft.y) ||
      (dispY > ((silkP + alphaI)->bounds.topLeft.y) + 
       (silkP + alphaI)->bounds.extent.y / 2)) {
    return(-1);
  }
  if (dispX < (silkP + alphaI)->bounds.topLeft.x) {
    return(-1);
  }
  if (dispX < ((silkP + alphaI)->bounds.topLeft.x +
	       (silkP + alphaI)->bounds.extent.x / 2)) {
    return(0);
  }
  if (dispX < (silkP + numericI)->bounds.topLeft.x) {
    return(1);
  }
  if (dispX < ((silkP + numericI)->bounds.topLeft.x + 
	       (silkP + numericI)->bounds.extent.x)) {
    return(2);
  }
  return(-1);
}
*/
// Returned:
//	error	-1
Int GetGraffitiRegion(SWord screenX, SWord screenY,
		      ULong encoding, ULong romVersion)
{
  SWord dispX, dispY;
  RectangleType alphaEntry, numericEntry;

  //  ErrorPrintNum(screenX, 110, 0);
  //  ErrorPrintNum(screenY, 130, 0);
  
  if (GetAreas(&alphaEntry, &numericEntry, romVersion) != errNone) {
    return(-1);
  }

  dispX = screenX;
  dispY = screenY;
  WinWindowToDisplayPt(&dispX, &dispY);
  
  if ((dispY < alphaEntry.topLeft.y) ||
      (dispY > alphaEntry.topLeft.y + (alphaEntry.extent.y / 2))) {
    return(-1);
  }
  if (dispX < alphaEntry.topLeft.x) {
    return(-1);
  }
  if (dispX < alphaEntry.topLeft.x + alphaEntry.extent.x / 2) {
    return(0);
  }
  if (dispX < numericEntry.topLeft.x) {
    return(1);
  }
  if (dispX < numericEntry.topLeft.x + numericEntry.extent.x) {
    return(2);
  }
  return(-1);
}

/*
Int GetGraffitiRegion(SWord screenX, SWord screenY,
		      ULong encoding, ULong romVersion)
{
  SWord dispX, dispY;
  SWord currHwrGraffitiLeft;
  
  dispX = screenX;
  dispY = screenY;
  WinWindowToDisplayPt(&dispX, &dispY);

  if (romVersion >= 0x03000000) {
    //    ErrorPrint("ROM > 35", 0, 150);
    return(GetGraffitiRegionOS35(screenX, screenY));
  }

  //  currHwrGraffitiLeft = (encoding == charEncodingCP932) ? 40 : hwrGraffitiLeft;
  currHwrGraffitiLeft = (encoding == MyCharEncodingPalmSJIS) ? 45 : hwrGraffitiLeft;

  if ((dispY < hwrGraffitiTop) ||
      (dispY > hwrGraffitiTop + (hwrGraffitiHeight / 2))) {
    return(-1);
  }
  if (dispX < currHwrGraffitiLeft) {
    return(-1);
  }
  if (dispX < currHwrGraffitiLeft +
      (hwrGraffitiSplit - currHwrGraffitiLeft) / 2) {
    return(0);
  }
  if (dispX < hwrGraffitiSplit) {
    return(1);
  }
  if (dispX < currHwrGraffitiLeft + hwrGraffitiWidth) {
    return(2);
  }
  return(-1);
}
*/

void ScaleToFitTo160(Coord *x, Coord *y)
{
  UInt32 version, romVerMajor;
  //  VgaScreenStateType state;
  VgaScreenModeType mode;
  VgaRotateModeType rotation;
  FormType *formP;

  if (FtrGet(TRGSysFtrID, TRGVgaFtrNum, &version) == 0) {
    if ((romVerMajor = sysGetROMVerMajor(version)) == 1)  {
      // the VGA Extension 1.0 is present
      VgaGetScreenMode(&mode, &rotation);
      //    VgaGetScreenState(&state);
      formP = FrmGetActiveForm();
      //      ErrorPrintNum(formP->formId, 120, 0);
      if ((mode == screenModeScaleToFit) ||
	  ((mode == screenMode1To1) &&
	   (formP->formId == 10500))) {
	switch (rotation) {
	case rotateModeNone:
	  //	  ErrorPrint("                 ", 0, 0);
	  //	  ErrorPrint("                 ", 0, 10);
	  //	  ErrorPrintNum(*x, 0, 0);
	  //	  ErrorPrintNum(*y, 30, 0);
	  *x = ((*x * 2) / 3);
	  *y = ((*y * 2) / 3);
	  //	  ErrorPrintNum(*x, 0, 10);
	  //	  ErrorPrintNum(*y, 30, 10);

	  break;
	case rotateMode90:
	case rotateMode180:
	case rotateMode270:
	  break;
	default:
	  break;
	}
      }
    }
    if ((romVerMajor = sysGetROMVerMajor(version)) > 1)  {
    }
  }
}

void MyInsPtGetLocation(Int16 *x, Int16 *y)
{

  InsPtGetLocation(x, y);
  ScaleToFitTo160(x, y);
  return;
}


#endif
